if(!dojo._hasResource["com.ibm.dnd.CustomManagerSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.dnd.CustomManagerSource"] = true;
dojo.provide("com.ibm.dnd.CustomManagerSource");

dojo.require("dojo.dnd.Source");

com.ibm.dnd.CustomManagerMixin = {
		// summary: An extension of the dojo.dnd.Source base module which provides 
		//		automatic declarative support for overriding properties on the dnd
		//		manager dynamically when a drag operation originates from this source.
		//		All properties that are overriden are reset back to their original
		//		values once the drag operation ends, regardless of the target or
		//		the outcome.  Customizing the dnd manager from a dnd Source is easily
		//		done by extending this module and overriding the managerOverrides
		//		map in the extension.
		
		// managerOverrides: Object
		//		Map of properties to override in the dojo.dnd.Manager instance returned
		//		by dojo.dnd.manager() when onMouseDown occurs in this dnd Source.
		//		The properties defined here will override the same properties in the
		//		dnd manager, and then reset back to what they were before after the
		//		drag operation ends.
		managerOverrides: {},
		
		_partialMixin: function(tgt, src, map) {
			// summary: Performs a partial, simple mixin from the src to the tgt as defined
			// 		by the map.  For each property defined in map, it sets the value of 
			// 		that property in tgt to the value of that same property in src.
			for(var p in map) {
				tgt[p] = src[p];
			}
			return tgt;
		},
		
		_changeManager: function() {
			// only fix once
			if(!this._mgr) {
				this.mgrProps = {};
				this._mgr = dojo.dnd.manager();
				this._partialMixin(this.mgrProps, this._mgr, this.managerOverrides);
				dojo.mixin(this._mgr, this.managerOverrides);
				this._mgrFixConn = dojo.connect(dojo.doc, "onmouseup", this, "_fixManager");
			}
		},
		_fixManager: function() {
			if(this._mgrFixConn) {
				dojo.disconnect(this._mgrFixConn);
				this._mgrFixConn = null;
			}
			if(this._mgr) {
				dojo.mixin(this._mgr, this.mgrProps);
				this.mgrProps = {};
			}
			// reset
			this._mgr = null;
		},
		onMouseDown: function(e){
			// summary: Plugin to change the dojo.dnd manager instance using the dynamic
			//		hot replace/fix paradigm.
			this._changeManager();
			this.inherited(arguments);
		},
		destroy: function() {
			// safety if for some reason we get destroyed before fixing the manager
			if(this._mgrFixConn) dojo.disconnect(this._mgrFixConn);
			this._mgrFixConn = null;
			this.inherited(arguments);
		}
	}

dojo.declare("com.ibm.dnd.CustomManagerSource",
	dojo.dnd.Source,
	com.ibm.dnd.CustomManagerMixin
);

dojo.declare("com.ibm.dnd.CustomManagerAutoSource",
	dojo.dnd.AutoSource,
	com.ibm.dnd.CustomManagerMixin
);

}
