dojo.provide("com.ibm.pb.customize.LotusDialog");

dojo.declare("com.ibm.pb.customize.LotusDialog", [dijit.Dialog], {
	blankImg: "",
    titleText: "",
    okText: "OK",
	duration: 1,
    destroyOnClose: false,
    templateString: '<div class="lotusDialogBorder lotusui30 lotusui" waistate="labelledby-${id}" wairole="dialog" role="dialog" index="-1" aria-labelledby="${id}">' +
		'<div class="lotusDialog">' +
			'<h1>' +
				'<a href="javascript:void(0);" role="button" dojoAttachPoint="closeButtonNode" class="lotusBtnImg lotusClose" title="${closeText}">' +
					'<img src="${blankImg}" aria-label="${closeText}" alt=""/>' +
					'<span class="lotusAltText">X</span>' +
				'</a>' +
				'<span dojoAttachPoint="titleNode">${titleText}</span>' +
			'</h1>' +
			'<div dojoAttachPoint="containerNode">' +
				'<div dojoAttachPoint="contentNode" class="lotusDialogContent"></div>' +
				'<div class="lotusDialogFooter">' +
					'<input value="${okText}" role="button" class="lotusFormButton" dojoAttachPoint="submitNode" type="submit" dojoAttachEvent="onclick: submit"/> ' +
					'<a href="javascript:void(0);" role="button" dojoAttachPoint="closeLinkNode" class="lotusAction">${cancelText}</a>' +
				'</div>' +
			'</div>' +
		'</div>' +
    '</div>',
    
    postMixInProperties: function(){
        this.nlsBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
        this.closeText = this.nlsBundle["shelf_closeDialog"];
        this.cancelText = this.nlsBundle["add_content_cancel"];
        if(this.cssStateNodes) {
			delete this.cssStateNodes.closeButtonNode;
        }
        this.inherited(arguments);
    },
    
    onSubmit: function(){
    },
    
    submit: function(){
        this.onSubmit();
    },
    hide: function(){
    	if(this.domNode) {
    		// internal hide doesn't check for domNode's existence, which in some cases may be null
    		// if hide is called after the widget is destroyed (ex. asynchronously)
    		return this.inherited(arguments);
    	}
    },
    cancel: function(){
    	if(!this._destroyingOnClose) {
	        this.hide();
	        if (this.destroyOnClose) {
	            this._destroyingOnClose = true; // protect from potential recursive loops
	            this.destroy();
	        }
    	}
    },
    
    setContent: function(content, title, okText, submitFcn){
        dojo.empty(this.contentNode);
        if (dojo.isString(content)) 
            content = document.createTextNode(content);
        this.contentNode.appendChild(content);
        this.titleNode.innerHTML = title || this.titleText;
        this.submitNode.value = okText || this.okText;
        this.onSubmit = submitFcn || function(){};
        this.show();
		this.onLoad(); // we reuse the same dialog instance for daisy-chained dialogs, so reload the dialog to reposition and refocus in case it was already open, in which case the show does not do this for us
    }
});
