/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.io.XHRMultipart");

dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.enabler.DeferredOperation");

//<INTERFACE>
/**
 * Provides Dojo XHR support.  Requests are batched together via a transaction
 * concept - Dojo XHR requests which are made between the start and end
 * transaction calls will be batched.  This would include any Dojo API's which would
 * use Dojo XHR.  If the com.ibm.mashups.multipart.correlatehosts
 * Configuration Service property is set to true, multipart requests will be
 * split by hostname.
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.io.XHRMultipart", null, {
    /**
     * @private
     */
    constructor: function() {
    },
    
    /**
     * Begins a multipart transaction.  If the com.ibm.mashups.multipart.enabled
     * property is set to false, this method simply returns.
     * @type void
     */
    startTransaction: function() {
    },
    
    /**
     * Ends a multipart transaction and submits the multipart request to
     * the server.  If the com.ibm.mashups.multipart.enabled
     * property is set to false, this method simply returns.
     * @return {DeferredOperation} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is <code>null</null>
     */
    endTransactionDeferred: function() {
    },
	
	/**
     * Ends a multipart transaction and submits the multipart request to
     * the server.  If the com.ibm.mashups.multipart.enabled
     * property is set to false, this method simply returns.
     * @param {Object} callback the callback funtion in the format of <code>Function(Object[] params)</code>. May be <code>null</code><br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<b>Callbackparameters</b><br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - the parameters
     * passed into the callback
     * @param {Object[]} parameters optional array of parameters to be
     * passed on to the callback function. May be <code>null</code>
     * @type void
     * @deprecated Use endTransactionDeferred instead.
     */
    endTransaction: function(callback, parameters) {
    },
    
    /**
     * Suspends a mulitpart transaction, allowing normal XHR requests
     * to be made.  If the com.ibm.mashups.multipart.enabled
     * property is set to false, this method simply returns.
     * @type void
     */
    suspendTransaction: function() {
    },
    
    /**
     * Resumes a mulitpart transaction.  If the com.ibm.mashups.multipart.enabled
     * property is set to false, this method simply returns.
     * @type void
     */
    resumeTransaction: function() {
    },

    /**
     * Returns if there is an active multipart transaction
     * @return {Boolean} <code>true</code> if there is an active multipart
     * transaction, <code>false</code> otherwise
     */
    isTransaction: function() {
        return false;
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.io.XHRMultipartImpl");
